<template>
  <base-dialog :show="!!error" title="Wystąpił błąd!" @close="handleError">
    {{ error }}
  </base-dialog>
  <base-card>
    <div v-if="isLoading">
      <base-spinner></base-spinner>
    </div>
    <div v-else-if="!isLoading && hasData">
      <ul>
        <screenings-day-list
          v-for="screenings in dayScreenings"
          :key="screeningsKey(screenings)"
          :screenings="screenings"
        ></screenings-day-list>
      </ul>
    </div>
    <div v-if="!isLoading && !hasData">
      <h1>Nie ma dostępnych seansów.</h1>
    </div>
  </base-card>
</template>

<script setup>
import ScreeningsDayList from "@/components/ScreeningsDay.vue";
import { ref, onMounted, computed } from "vue";
import { useStore } from "vuex";

const store = useStore();

const isLoading = ref(false);
const error = ref(null);

async function loadData() {
  isLoading.value = true;
  try {
    await store.dispatch("loadData");
  } catch (er) {
    error.value = er.message || "Nie udało się załadować prac zaliczeniowych.";
  }
  isLoading.value = false;
}

const hasData = computed(function () {
  return store.getters.screenings.length > 0;
});
// const screenings = computed(function () {
//   return store.getters.screenings;
// });
const dayScreenings = computed(function () {
  return groupDayScreenings(store.getters.screenings);
});
const screeningsKey = function (group) {
  return group[0].dateTime.substring(0, 10);
};

function handleError() {
  error.value = null;
}

function groupDayScreenings(screenings) {
  const grouped = [];
  const groupedDates = [];
  for (let i = 0; i < screenings.length; i++) {
    const date = screenings[i].dateTime.substring(0, 10);
    if (groupedDates.includes(date)) {
      const index = groupedDates.indexOf(date);
      grouped[index].push(screenings[i]);
    } else {
      groupedDates.push(date);
      grouped.push([screenings[i]]);
    }
  }
  return grouped;
}

onMounted(async function () {
  await loadData();
});
</script>
